#!/usr/bin/perl -w
# Auteur <julien@vaubourg.com> pour le CRI de INPL
# 2010 - Centreon 2.0.2

# Tente de creer un nrpe.cfg a partir des informations du Centreon

use strict;
use warnings;
use DBI;

my $mysql = DBI->connect('DBI:mysql:database=centreon2;host=localhost', 'tmp', 'tmp', { 'RaiseError' => 1 });

# Selection de tous les parametres passes a une commande check_nrpe
my $sql = $mysql->prepare("SELECT command_command_id_arg arg
				FROM service
				WHERE command_command_id IN (SELECT command_id
								FROM command
								WHERE command_name
								LIKE 'check_nrpe%')");
$sql->execute;

my %cmds;

# Pour chaque ligne de parametres de NRPE
while(my $r = $sql->fetchrow_hashref) {
	my $arg = $r->{'arg'};

	# Centreon remplace les slashs par des #S#
	$arg =~ s/#S#/\//g;

	# Separation des arguments
	my @args = split('!', $arg);

	# Le nom de la commande distante est en premier
	shift @args;

	# Les arguments ensuite
	my $c = shift @args;

	# Tentative d'ecriture de nrpe.cfg
	$cmds{$c.@args} = "command[$c] = /usr/lib/nagios/plugins/$c ".join('     ', @args)."\n";
}

# Affichage par ordre alphabetique
for (sort keys %cmds) {
	print $cmds{$_};
}

$sql->finish;
$mysql->disconnect;
