#!/usr/bin/perl -w
# Auteur <julien@vaubourg.com> pour le CRI de INPL
# 2010 - Centreon 2.0.2

# Attribut un template d'host a tous les hosts d'un groupe

use strict;
use warnings;
use DBI;

my $mysql = DBI->connect('DBI:mysql:database=centreon2;host=localhost', 'tmp', 'tmp', { 'RaiseError' => 1 });
my $h;

# Group source
print "Hostgroup des hosts de depart : ";
my $from = <>;
chomp($from);

# Tpl de destination
print "Tpl host de destination : ";
my $to = <>;
chomp($to);

# Verification de l'existence du tpl de destination
my $sql = $mysql->prepare("SELECT TRUE FROM host WHERE host_name=".$mysql->quote($to)." AND host_register='0'");
$sql->execute;

if($sql->rows == 0) {
	print STDERR "ERREUR: Le TPL d'hote ".$mysql->quote($to)." n'existe pas.\n";
	exit 1;
}

# Selection des hosts du hostgroup qui n'ont pas encore le tpl d'attribue
$sql = $mysql->prepare("SELECT host_host_id id
			FROM hostgroup_relation
			WHERE hostgroup_hg_id=(SELECT hg_id
						FROM hostgroup
						WHERE hg_name=".$mysql->quote($from).")
			AND host_host_id NOT IN (SELECT host_host_id
						FROM host_template_relation
						WHERE host_tpl_id=(SELECT host_id
								FROM host
								WHERE host_name=".$mysql->quote($to)."
								AND host_register='0'))");
$sql->execute;
my $nbHosts = $sql->rows;

# Association des hosts trouves avec le tpl donne
$mysql->do("INSERT INTO host_template_relation (
		host_tpl_id,
		host_host_id
	) VALUES (
		(SELECT host_id FROM host WHERE host_name=".$mysql->quote($to)." AND host_register='0'),
		".$h->{'id'}."
	)") while($h = $sql->fetchrow_hashref);

print "\nINFO: Les $nbHosts hosts appartenant a $from ont ete noues avec le tpl $to.\n";

$mysql->disconnect;
