#!/usr/bin/perl -w
# Auteur <julien@vaubourg.com> pour le CRI de INPL
# 2010 - Centreon 2.0.2

# Copie les hosts d'un hostgroup dans un autre

use strict;
use warnings;
use DBI;

my $mysql = DBI->connect('DBI:mysql:database=centreon2;host=localhost', 'tmp', 'tmp', { 'RaiseError' => 1 });
my $h;

# Hostgroup des machines a copier
print "Groupe de depart : ";
my $from = <>;
chomp($from);

# Hostgroup de destination de ces machines
print "Groupe de destination : ";
my $to = <>;
chomp($to);

# Verification de l'existence du hostgroup de destination
my $sql = $mysql->prepare("SELECT TRUE FROM hostgroup WHERE hg_name=".$mysql->quote($to));
$sql->execute;

if($sql->rows == 0) {
	print STDERR "ERREUR: Le groupe d'hotes ".$mysql->quote($to)." n'existe pas.\n";
	exit 1;
}

# Selection des hosts qui sont dans le groupe de depart mais pas encore dans le groupe de destination
$sql = $mysql->prepare("SELECT host_host_id id FROM hostgroup_relation
				WHERE hostgroup_hg_id=(SELECT hg_id
							FROM hostgroup
							WHERE hg_name=".$mysql->quote($from).")
				AND host_host_id NOT IN (SELECT host_host_id
								FROM hostgroup_relation
								WHERE hostgroup_hg_id=(SELECT hg_id
											FROM hostgroup
											WHERE hg_name=".$mysql->quote($to)."))");

$sql->execute;

my $nbHosts = $sql->rows;

# Insertion des hosts a copier dans le groupe de destination
$mysql->do("INSERT INTO hostgroup_relation (
		hostgroup_hg_id,
		host_host_id
	) VALUES (
		(SELECT hg_id FROM hostgroup WHERE hg_name=".$mysql->quote($to)."),
		".$h->{'id'}."
	)") while($h = $sql->fetchrow_hashref);

print "\nINFO: Les $nbHosts hosts appartenant a $from (et qui n'etaient pas deja dans $to) ont ete copies dans $to.\n";

$mysql->disconnect;
