#!/usr/bin/perl -w
# Auteur <julien@vaubourg.com> pour le CRI de INPL
# 2010 - Centreon 2.0.2

use strict;
use warnings;
use DBI;

my $mysql = DBI->connect('DBI:mysql:database=centreon2;host=localhost', 'tmp', 'tmp', { 'RaiseError' => 1 });

# Selection des templates de services
my $sqlTpl = $mysql->prepare("SELECT * FROM service WHERE service_register='0'");
$sqlTpl->execute;

# Pour chaque tpl de service
while(my $tpl = $sqlTpl->fetchrow_hashref) {

	# Copies des informations du template directement dans le service
	while(my ($k, $v) = each %$tpl) {
		$mysql->do("UPDATE service
				SET $k='$v'
				WHERE service_template_model_stm_id=".$tpl->{'service_id'}." AND $k IS NULL") if $v;
	}

	# Selection des services dependants de ce tpl
	my $sqlServices = $mysql->prepare("SELECT service_id
						FROM service
						WHERE service_template_model_stm_id=".$tpl->{'service_id'});
	$sqlServices->execute;

	# Pour chaque service ayant pour template le tpl courant
	while(my $service = $sqlServices->fetchrow_hashref) {

		# Recuperation des contacts relies au tpl
		my $sqlTplContacts = $mysql->prepare("SELECT contact_id
							FROM contact_service_relation
							WHERE service_service_id=".$tpl->{'service_id'});
		$sqlTplContacts->execute;

		# Pour chaque contact associe au tpl courant, on l'associe directement au service courant
		while(my $contact = $sqlTplContacts->fetchrow_hashref) {
			$mysql->do("INSERT INTO contact_service_relation(
				service_service_id,
				contact_id
			) VALUES (
				".$service->{'service_id'}.",
				".$contact->{'contact_id'}."
			)");
		}

		# Recuperation des groupes de contacts relies au tpl
		my $sqlTplContactgroups = $mysql->prepare("SELECT contactgroup_cg_id
								FROM contactgroup_service_relation
								WHERE service_service_id=".$tpl->{'service_id'});
		$sqlTplContactgroups->execute;

		# Pour chaque contactgroup associe au tpl courant, on l'associe directement au service courant
		while(my $contactgroup = $sqlTplContactgroups->fetchrow_hashref) {
			$mysql->do("INSERT INTO contactgroup_service_relation(
				service_service_id,
				contactgroup_cg_id
			) VALUES (
				".$service->{'service_id'}.",
				".$contactgroup->{'contactgroup_cg_id'}."
			)");
		}

		$sqlTplContacts->finish;
		$sqlTplContactgroups->finish;
	}

	# A present que toutes les informations du tpl ont ete directement associees aux services correspondant, on denoue ces services du tpl
	$mysql->do("UPDATE service SET service_template_model_stm_id=1 WHERE service_template_model_stm_id=".$tpl->{'service_id'});
}

$sqlTpl->finish;
$mysql->disconnect;
