#!/bin/bash
# Auteur <julien@vaubourg.com> 2010
# complete par Pierre MAFFEIS

# A executer dans le repertoire parent de $scripts
#
# Dans le dossier $scripts :
# - machines (un nom de machine par ligne)
# - winexe
# - nrpe.delta.cfg
# - cent_checks/


# Repertoire principal
rep=scripts

# Compte administrateur
admin=root

# Mot de passe des Windows
echo -n "Mot de passe Admin : "
read -s mdp

# Pour chaque machine windows
while read host; do
        # Sort le nom court de la machine
        host_nbt=`echo $host|cut -d . -f 1`

        echo "Mount de c: et d: en local"
        mount -t cifs -o "username=$admin%$mdp" '//'$host'/c$' $rep/c
        mount -t cifs -o "username=$admin%$mdp" '//'$host'/d$' $rep/d

        echo "Recherche de nrpe.cfg sur les deux partitions"
        path_nrpe=$(find $rep -name nrpe.cfg | head -n1)

        if [ ! -z "$path_nrpe" ]; then
        echo "nrpe.cfg a ete trouve : "$path_nrpe

                # Suppression de nrpe.cfg pour ne garder que le path
                path_nrpe=${path_nrpe%/*}

                echo -n "Arret de NRPE...."
                cat $rep/stop_nrpe.bat|$rep/winexe --uninstall --runas=$host_nbt/$admin%$mdp -U $host_nbt/$admin%$mdp //$host cmd >> /dev/null && echo OK || echo NOK

                if [ "$path_nrpe" != "$rep/c/NRPE" ]; then

                        # Suppression de $rep, transformation de d/ en d:\\ et transformation des /
                        # en \\ (double pour sed)
                        path_nrpe_win=${path_nrpe#*/}
                        path_nrpe_win=${path_nrpe_win/\//:\\\\}
                        path_nrpe_win=${path_nrpe_win//\//\\\\}

                        # Remet un fichier uninstall par defaut
                        cp -f $rep/uninstall_nrpe_template.bat $rep/uninstall_nrpe.bat

                        # Adapte le fichier uninstall
                        sed "s/ancien_dossier/$path_nrpe_win/gi" -i $rep/uninstall_nrpe.bat
                        sed "s/lecteur/${path_nrpe_win%:*}/gi" -i $rep/uninstall_nrpe.bat

                        echo "Copie outils de suppression"
                        cp $rep/unlocker.exe $rep/c/

                        echo -n "Desintallation et deplacement de NRPE...."
                        #cat $rep/uninstall_nrpe.bat|$rep/winexe --uninstall --runas=$host_nbt/$admin%$mdp -U $host_nbt/$admin%$mdp //$host cmd >> /dev/null && echo OK || echo NOK
                        cat $rep/uninstall_nrpe.bat|$rep/winexe --uninstall --runas=$host_nbt/$admin%$mdp -U $host_nbt/$admin%$mdp //$host cmd

                        # Suppression de l'outils de suppression
                        #rm $rep/c/unlocker.exe

                        # echo "Changement de repertoire NRPE"
                        #mv "$path_nrpe" $rep/c/NRPE

                        # Mise a jour des chemins des anciens checks
                        sed "s/$path_nrpe_win/c:\\\\NRPE/gi" -i $rep/c/NRPE/nrpe.cfg

                        echo -n "Installation de NRPE...."
                        cat $rep/install_nrpe.bat|$rep/winexe --uninstall --runas=$host_nbt/$admin%$mdp -U $host_nbt/$admin%$mdp //$host cmd >> /dev/null && echo OK || echo NOK
                fi

                echo "Mise a jour du nrpe.cfg pour les nouveaux checks"
                cat $rep/nrpe.delta.cfg >> $rep/c/NRPE/nrpe.cfg

                echo "Copie des nouveaux checks"
                cp -r $rep/cent_checks $rep/c/NRPE

                echo -n "Demarrage de NRPE...."
                cat $rep/start_nrpe.bat|$rep/winexe --uninstall --runas=$host_nbt/$admin%$mdp -U $host_nbt/$admin%$mdp //$host cmd >> /dev/null && echo OK || echo NOK

        # nrpe.cfg n'existe pas : pas de nrpe d'installe ??
        else
                echo "$host : Aucune nrpe.cfg sur c: et d:\n" >&2
        fi

        # Umount de c: et d:
        umount $rep/c
        umount $rep/d

        # Une petite pause
        sleep 6

done < $rep/machines
