#!/usr/bin/perl -w
# Auteur <julien@vaubourg.com> pour le CRI de INPL
# 2010 - Centreon 2.0.2

# Selectionne tous les hosts qui contiennent un mot dans leur nom de domaine
# et qui repondent sur le port 22

use strict;
use warnings;
use DBI;
use Net::Ping;
use List::Util 'first';

my $mysql = DBI->connect('DBI:mysql:database=centreon2;host=localhost', 'tmp', 'tmp', { 'RaiseError' => 1 });

my $sql = $mysql->prepare("SELECT host_address addr
				FROM host
				WHERE host_register='1'")
;
$sql->execute;

# Mot a filtrer
print "Ecole a filtrer : ";
my $school = <>;
chomp($school);

my @hosts;
my $i = 0;

# Debut de la barre de chargement
print "\n[";

# Pour chacun des hosts
while(my $h = $sql->fetchrow_hashref) {
	my $addr = $h->{'addr'};

	# DNS inverse pour recuperer le nom de domaine
	my $dns = `host $addr | awk '\$NL ~ /pointer/ { print substr(\$NF, 0, length(\$NF)-1) }' | tail -n1`;

	# L'host a un nom de domaine
	if($dns ne '') {
		chomp($dns);

		# Progression de la barre de chargement
		print '|' if ++$i%2;

		# Si le nom de domaine contient le mot
		if($dns =~ /$school/i) {

			# On delegue a une machine tierce qui en a les droits, la charge de verifier
			# si la machine repond au ping sur le port SSH
			`ssh nagiosBrabois "perl -e '\\\
				use Net::Ping;\\\
				my \\\$ssh = Net::Ping->new(\\"tcp\\", 3);\\\
				\\\$ssh->{port_num} = 22;\\\
				exit substr(\\\$ssh->ping(\\"$dns\\"), 0, 1);'"`;

			# Si c'est le cas, on l'ajoute a la liste
			if($?) {
				push(@hosts, $dns) unless first { $_ eq $dns } @hosts;
			}
		}
	}
}

# Sortie pour en syntaxe CSSH
print "]\n\ncssh ";

print "root\@$_ " for (@hosts);
print "\n\n";
print "$_\n" for (@hosts);
print "\n";

$sql->finish;
$mysql->disconnect;
