#!/usr/bin/perl -w
# Auteur <julien@vaubourg.com> pour le CRI de INPL
# 2010 - Centreon 2.0.2

# Deplace les hosts d'un hostgroup vers un autre hostgroup

use strict;
use warnings;
use DBI;

my $mysql = DBI->connect('DBI:mysql:database=centreon2;host=localhost', 'tmp', 'tmp', { 'RaiseError' => 1 });
my $h;

# Hostgroup a partir duquel il faut copier les hosts
print "Groupe de depart : ";
my $from = <>;
chomp($from);

# Hostgroup dans lequel les copier
print "Groupe de destination : ";
my $to = <>;
chomp($to);

# Verification de l'existence du hostgroup de destination
my $sql = $mysql->prepare("SELECT TRUE FROM hostgroup WHERE hg_name=".$mysql->quote($to));
$sql->execute;

if($sql->rows == 0) {
	print STDERR "ERREUR: Le groupe d'hotes ".$mysql->quote($to)." n'existe pas.\n";
	exit 1;
}

# Selection de tous hosts du hostgroup source qui ne sont pas dans le groupe de destination
$sql = $mysql->prepare("SELECT host_host_id id FROM hostgroup_relation
			WHERE hostgroup_hg_id=(SELECT hg_id
						FROM hostgroup
						WHERE hg_name=".$mysql->quote($from).")
			AND host_host_id NOT IN (SELECT host_host_id
							FROM hostgroup_relation
							WHERE hostgroup_hg_id=(SELECT hg_id
										FROM hostgroup
										WHERE hg_name=".$mysql->quote($to)."))");

$sql->execute;

my $nbHosts = $sql->rows;

# Deviation des liaisons entre les hosts et leur ancien hostgroup pour les faire pointer vers leur
# nouveau hostgroup
$mysql->do("UPDATE hostgroup_relation
		SET hostgroup_hg_id=(SELECT hg_id FROM hostgroup WHERE hg_name=".$mysql->quote($to).")
		WHERE hostgroup_hg_id=(SELECT hg_id FROM hostgroup WHERE hg_name=".$mysql->quote($from).")
		AND host_host_id=".$h->{'id'}
	) while($h = $sql->fetchrow_hashref);

print "\nINFO: Les $nbHosts hosts appartenant a $from (et qui n'etaient pas deja dans $to) ont ete deplaces vers $to.\n";

# Confirmation de la suppression du hostgroup a present vide, ou uniquement rempli des hosts qui etaient
# deja dans le groupe de destination
print "\nSupprimer le groupe $from (Y/n) ? ";
my $del = <>;
chomp($del);

# Suppression
if($del =~ /^[yo]?$/i) {
	$mysql->do("DELETE FROM hostgroup_relation WHERE hostgroup_hg_id=(SELECT hg_id FROM hostgroup WHERE hg_name=".$mysql->quote($from).")");
	$mysql->do("DELETE FROM hostgroup WHERE hg_name=".$mysql->quote($from));
	print "INFO: Le groupe d'hotes $from a ete supprime.\n";
}
	
$mysql->disconnect;
